#include <mega128.h>
#include <delay.h>
#include <stdio.h>
#include <stdlib.h>
#include "font.h"
#include "lcd_ls022.h"
#include "sigma12.h"
#include "bmp.h"


#pragma optsize+

void SendCom (unsigned int com)
{
 CS = 0;
 DC = 0;
 DAT = com;
 WR = 0;
 WR = 1;
// DC = 1;
 CS = 1;
}
void SendDat (unsigned int dat)
{
 CS = 0;
 DC = 1;
 DAT = dat;
 WR = 0;
 WR = 1;
 CS = 1;
 }          
                
//#define WriteByte(data, comdat) { DC = (unsigned int )comdat; DAT = (unsigned int )data; WR = 0; WR = 1;}
////#define WriteData(data) { DAT = (unsigned int )data; PORTC = 4+2;/* WR = 0;*/ WR = 1;}
//#define WriteData(data) { DC = 1; DAT = (unsigned int )data;  WR = 0; WR = 1;}
 
void WriteByte_ (unsigned int data, unsigned int comdat)
{
//    CS = 0;
//    if (comdat)
 //DC = comdat;  //1
//    else
 //DC = comdat;  //0
 DC = comdat;  //0
 DAT = data;
 WR = 0;
 WR = 1;
// DCX = 1;
 //CS = 1;
}
void LCDinit ()
{
  RESX = 0;
  delay_ms(1);
  RESX = 1;
  delay_ms(5);
  CS = 0;
  WriteByte(0x11,COMMAND);       // Sleep Out
  WriteByte(0x29,COMMAND);       // Display On
  delay_ms(1);
  WriteByte(0x13,COMMAND);
  WriteByte(0x36,COMMAND);       // direction & color mode RGB - BGR
  WriteByte(0x00,DATA); //0xc0  
  WriteByte(0x3A,COMMAND);       // Interface Pixel Format
  WriteByte(0x07,DATA);//  24 Bit mode
  CS = 1;
}
  
void LCDclear()
{ 
  //register unsigned long int i;
  register unsigned int y;
  register unsigned char x;
  
  CS = 0;
    
  /*WriteByte(0x2a,COMMAND);      
  WriteByte(0x00,DATA);      
  WriteByte(0x00,DATA);      
  WriteByte(0x00,DATA);      
  WriteByte(239,DATA);      
  WriteByte(0x2b,COMMAND);      
  WriteByte(0x00,DATA);      
  WriteByte(0x00,DATA);      
  WriteByte(1,DATA);      
  WriteByte(63,DATA);*/      
     SendCom(0x2A);
     SendDat(0);  SendDat(0);    // x1
     SendDat(0);  SendDat(239);  // x2
     SendCom(0x2B);
     SendDat(0);  SendDat(0);    // y1
     SendDat(1);  SendDat(63);  // y2
     SendCom(0x2C);
//  WriteByte(0x2c,COMMAND);
  CS = 0;         
  DC = 1;
  DAT=0;      
//  i = 320L*240L;
 for (y=0;y<320;y++)
 for (x=0;x<240;x++)
 {
  WR=0; WR=1; WR=0; WR=1; WR=0; WR=1;
/*  WriteByte(0,DATA);      
  WriteByte(0,DATA);      
  WriteByte(0,DATA);*/      
 } 
/*  for (i=0;i<7680;i++) {   
  DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1;
  DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1;
  DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1;
  DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1;
  DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1;
  DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1;
  DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1;
  DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1;
  DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1;
  DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1;
  }*/
  
  
/* for (x=0;x<240;x++)
 for (y=0;y<320;y++)
 {                                                              
 DAT=255;WR=0; WR=1; DAT=0;WR=0; WR=1; DAT=0;WR=0; WR=1;
 } */
/*  for (i=0;i<7680;i++) {   
  DAT=255; WR=0; WR=1; DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1;
  DAT=255; WR=0; WR=1; DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1;
  DAT=255; WR=0; WR=1; DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1;
  DAT=255; WR=0; WR=1; DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1;
  DAT=255; WR=0; WR=1; DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1;
  DAT=255; WR=0; WR=1; DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1;
  DAT=255; WR=0; WR=1; DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1;
  DAT=255; WR=0; WR=1; DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1;
  DAT=255; WR=0; WR=1; DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1;
  DAT=255; WR=0; WR=1; DAT=0; WR=0; WR=1; DAT=0; WR=0; WR=1;
  }*/ 
  CS = 1;      
}
#pragma optsize-
void lcd_fill_area( unsigned int x1,  unsigned int y1,  unsigned int x2,  unsigned int y2, char color_r, char color_g, char color_b)
{
//  register unsigned int y;
//  register unsigned char x;

//   unsigned int i, total; 
//   unsigned int q1,q2,s1,s2;
   register unsigned char c_r, c_g, c_b; 
   register unsigned char x;   
   register unsigned int y;
   unsigned char xl;   
   unsigned int yl;
   
   xl = x2 - x1 + 1;
   yl = y2 - y1 + 1;          
   c_r = color_r; 
   c_g = color_g; 
   c_b = color_b; 
   
/*   total = (x2-x1+1)*(y2-y1+1);
   if (y1<256) {s1=y1; s2=0;}
     if (y1>255) {s1=(y1-256); s2=1;}
     if (y2<256) {q1=y2; q2=0;}
     if (y2>255) {q1=(y2-256); q2=1;}*/
  CS = 0;     
     
     WriteByte(0x2A,COMMAND);
     WriteByte(0,DATA);  WriteByte(x1,DATA);    // x1
     WriteByte(0,DATA);  WriteByte(x2,DATA);    // x2
     WriteByte(0x2B,COMMAND);
//     WriteByte(s2,DATA);  WriteByte(s1,DATA);    // y1
//     WriteByte(q2,DATA);  WriteByte(q1,DATA);  // y2
     WriteByte(y1 >> 8,DATA);  WriteByte(y1,DATA);    // y1
     WriteByte(y2 >> 8,DATA);  WriteByte(y2,DATA);  // y2
     WriteByte(0x2C,COMMAND);
 y = yl;     
 while(y > 0) 
 {      
   x = xl;
   while(x > 0) 
   {
     WriteData(c_r);WriteData(c_g);WriteData(c_b);
     x--;
   }
   y--;
 }
 CS = 1;     
}
#pragma optsize_default

void LCDchar ( unsigned int x, unsigned int y, char c, char color_r, char color_g, char color_b, char bgcolor_r, char bgcolor_g, char bgcolor_b )
{    char h,ch,p,mask;
     unsigned int q1,q2,s1,s2;
     
CS = 0;     
     if (y<256) {s1=y; s2=0;}
     if (y>255) {s1=(y-256); s2=1;}
     if ((y+14)<256) {q1=(y+14); q2=0;}
     if ((y+14)>255) {q1=((y+14)-256); q2=1;}
     SendCom(0x2A);
     SendDat(0);  SendDat(x);    // x1
     SendDat(0);  SendDat(x+7);  // x2
     SendCom(0x2B);
     SendDat(s2);  SendDat(s1);  // y1
     SendDat(q2);  SendDat(q1);  // y2
     SendCom(0x2C);

 for (h=0; h<14; h++) // every column of the character
  {   
        ch=font[c][0+h];
        mask=0x80;
        for (p=0; p<8; p++)  // write the pixels
          {
          if (ch&mask)
            {SendDat(color_r);SendDat(color_g);SendDat(color_b);}
           else
            {SendDat(bgcolor_r);SendDat(bgcolor_g);SendDat(bgcolor_b);}
          mask=mask/2;
          }
  }    
  CS = 1;
}
void LCDtext(unsigned int x, unsigned int y, char *str, char color_r, char color_g, char color_b, char bgcolor_r, char bgcolor_g, char bgcolor_b, char m)
{
unsigned char  j=0;
  while (j<m) 
   {
    LCDchar (x+8*j,y,str[j],color_r,color_g,color_b,bgcolor_r,bgcolor_g,bgcolor_b);
    j++;
   }
} 
void LCDchislo(unsigned int x, unsigned int y, int ch, char color_r, char color_g, char color_b, char bgcolor_r, char bgcolor_g, char bgcolor_b)
{     
char buffer[4];
  if(ch>999)ch=999;
  itoa(ch, buffer); //   
  if(ch<100)
  {LCDchar(x+16,y,' ',color_r,color_g,color_b,bgcolor_r,bgcolor_g,bgcolor_b);}
  if(ch<10) 
  {LCDchar(x+8,y,' ',color_r,color_g,color_b,bgcolor_r,bgcolor_g,bgcolor_b);}
  LCDtext(x,y,buffer,color_r,color_g,color_b,bgcolor_r,bgcolor_g,bgcolor_b,3);    
} 
void LCDpixel (unsigned int x,unsigned int y, char color_r, char color_g, char color_b)
{    unsigned int s1,s2;

  CS = 0;
     if (y<256) {s1=y; s2=0;}
     if (y>255) {s1=(y-256); s2=1;}
     WriteByte(0x2A,COMMAND);
     WriteByte(0,DATA);  WriteByte(x,DATA);    // x1
     WriteByte(0,DATA);  WriteByte(x,DATA);    // x2
     WriteByte(0x2B,COMMAND);
     WriteByte(s2,DATA);  WriteByte(s1,DATA);  // y1
     WriteByte(s2,DATA);  WriteByte(s1,DATA);  // y2
     WriteByte(0x2C,COMMAND);
     WriteByte(color_r,DATA);WriteByte(color_g,DATA);WriteByte(color_b,DATA);
  CS = 1;  
}
/*void LCDpixel (unsigned int x,unsigned int y, char color_r, char color_g, char color_b)
{    unsigned int s1,s2;

     if (x<256) {s1=x; s2=0;}
     if (x>255) {s1=(x-256); s2=1;}
     SendCom(0x2A);
     SendDat(s2);  SendDat(s1);  // x1
     SendDat(s2);  SendDat(s1);  // x2
     SendCom(0x2B);
     SendDat(0);  SendDat(y);    // y1
     SendDat(0);  SendDat(y);    // y2
     SendCom(0x2C);
     SendDat(color_r);SendDat(color_g);SendDat(color_b);
     }*/
void LCDline ( int x1, int y1, int x2, int y2, char color_r, char color_g, char color_b )
{   int dx, dy, stepx, stepy, fraction;       
    dy = y2 - y1;
    dx = x2 - x1;
    if ( dy < 0 )
    {
        dy    = -dy;
        stepy = -1;
    }
    else
    {
        stepy = 1;
    }

    if ( dx < 0 )
    {
        dx    = -dx;
        stepx = -1;
    }
    else
    {
        stepx = 1;
    }
    dx <<= 1;
    dy <<= 1;
    
    if ( dx > dy )
    {
        fraction = dy - (dx >> 1);
        while ( x1 != x2 )
        {
            if ( fraction >= 0 )
            {
                y1 += stepy;
                fraction -= dx;
            }
            x1 += stepx;
            fraction += dy;
            LCDpixel ( x1, y1, color_r, color_g, color_b);//     
        }
    }
    else
    {
        fraction = dx - (dy >> 1);
        while ( y1 != y2 )
        {
            if ( fraction >= 0 )
            {
                x1 += stepx;
                fraction -= dy;
            }
            y1 += stepy;
            fraction += dx;
            LCDpixel ( x1, y1, color_r, color_g, color_b);//     
        }
    }
}     

#pragma optsize-
//flash unsigned char *pname;
void TFT12prnit( void )
{
//  flash unsigned char *pname;
  register unsigned int i, n;
//  register unsigned char temp;      
  register unsigned char x;
  register unsigned char y;            
  
  CS = 0;
  WriteByte(0x3A,COMMAND);       // Interface Pixel Format
  WriteByte(0x03,DATA);//12bit
  //unsigned char r,g,b;
 WriteByte(0x2A,COMMAND);              //   Y 
 WriteByte(0,DATA);  WriteByte(0,DATA);    //   Y  (0)
 WriteByte(0,DATA);  WriteByte(239,DATA);//SendDat(63);   //     Y  (320)

 WriteByte(0x2B,COMMAND);              // 
 WriteByte(0,DATA);  WriteByte(0,DATA);    //  (0)
 WriteByte(1,DATA);  WriteByte(63,DATA);  //       (240)

 WriteByte(0x2C,COMMAND);              //    
 //pname = &name[320*240*3/4 / 2];
 
 i = 0;
 //x = pname[i];
// for (i=0;i < 320*240*3/2;i++)
 //for (i=0;i <(15L*240L);i++)
 for (y=0;y<320*3/4 / 2;y++)
 for (x=0;x<240;x++)
 {
     WriteByte(name[i],DATA);
     i++;
     WriteByte(name[i],DATA);
     i++;
 }
 n = 0;
 for (y=0;y<320*3/4 / 2;y++)
 for (x=0;x<240;x++)
 {
     WriteByte(name[(unsigned long)i + (unsigned long)n],DATA);
     n++;
     WriteByte(name[(unsigned long)i + (unsigned long)n],DATA);
     n++;
 }
  
 WriteByte(0x3A,COMMAND);       // Interface Pixel Format
  WriteByte(0x07,DATA);//SendDat(0x07); // //  24  
 CS = 1; 
}
//------------------------------------------------------------------
void LCD_Draw_BMP12( flash unsigned char *bmp)
{
  register unsigned int i;
  register unsigned long n;
  register unsigned char x;
  register unsigned char y;            
                       
  CS = 0;
  WriteByte(0x3A,COMMAND);       // Interface Pixel Format
  WriteByte(0x03,DATA);//12bit
  WriteByte(0x2A,COMMAND);              //   Y 
  WriteByte(0,DATA);  WriteByte(0,DATA);    //   Y  (0)
  WriteByte(0,DATA);  WriteByte(239,DATA);//SendDat(63);   //     Y  (320)

  WriteByte(0x2B,COMMAND);              //     
  WriteByte(0,DATA);  WriteByte(0,DATA);    //     (0)
  WriteByte(1,DATA);  WriteByte(63,DATA);  //     (240)

  WriteByte(0x2C,COMMAND);              //    
                         
  //i = 0;
  i = (unsigned long)bmp;                   
  y = 320*3/4 / 2;
  while(y > 0)
  {                           
    x = 240;
    while(x > 0)
    {
      WriteByte(*(flash unsigned char *)i,DATA);
      i++;
      
      WriteByte(*(flash unsigned char *)i,DATA);
      i++;
      x--;
    }
    y--;
  }

  n = i;
//  i = 0;
  y = 320*3/4 / 2;
  while(y > 0)
  {                           
    x = 240;
    while(x > 0)
    {
//      WriteByte(*(flash unsigned char *)(n+(unsigned long)i),DATA);
      WriteByte(*(flash unsigned char *)n,DATA);
      n++;
      
//      WriteByte(*(flash unsigned char *)(n+(unsigned long)i),DATA);
      WriteByte(*(flash unsigned char *)n,DATA);
      n++;
      x--;
    }
    y--;
  }

  WriteByte(0x3A,COMMAND);       // Interface Pixel Format
  WriteByte(0x07,DATA);//SendDat(0x07); // //  24  
 
  CS = 1;
}
//------------------------------------------------------------------
#pragma optsize_default
